# UniTAP.dev.ports.modules.link.dp.link_tx

class LinkDisplayPortTx:

Class `LinkDisplayPortTx` contains information about DP link.

- Read link status `status`.
- Configure and read link configuration `config`.
- Get maximum stream count `max_stream_count`.
- Do link training `link_training`.
- Get last result of link training `last_lt_result`.
- Read and write scrambler seed value `scrambler_seed`.
- Set `set_override_voltage` and get `get_override_voltage` override voltage.
- Set `set_override_pre_emp` and get `get_override_pre_emp` override pre-emphasis.
- Set and get override FFE presets `override_ffe_presets`.
- Set and get link pattern `link_pattern` 'set_link_pattern'.
- Set and get force link config `LinkDisplayPortForceConfig`.

LinkDisplayPortTx( port_io: UniTAP.libs.lib_tsi.tsi_io.PortIO, dpcd: UniTAP.dev.ports.modules.dpcd.dpcd.DPCDRegisters, hw_caps: UniTAP.dev.ports.modules.link.dp.private_link_tx_types.DPTXHWCaps)
status: UniTAP.dev.ports.modules.link.dp.link_tx_status.LinkDisplayPortStatusSource

Returns object of class `LinkDisplayPortStatusSource` for working with link status.

###### Returns:

> object of `LinkDisplayPortStatusSource` type

config: UniTAP.dev.ports.modules.link.dp.link_tx_config.LinkDisplayPortConfig

Returns object of class `LinkDisplayPortConfig` for working with link configuration.

###### Returns:

> object of `LinkDisplayPortConfig` type

force_config: UniTAP.dev.ports.modules.link.dp.link_tx_force_config.LinkDisplayPortForceConfig

Returns object of class `LinkDisplayPortForceConfig` for working with link configuration.

###### Returns:

> object of `LinkDisplayPortForceConfig` type

max_stream_count

Returns maximum supported stream count.

###### Returns:

> object of int type

def start_link_training(self) -> bool:

Make link training. Returns 'True' state if link training was success, 'False' - if not.

###### Returns:

> object of bool type

def last_lt_result( self) -> UniTAP.dev.ports.modules.link.dp.link_status_common.DpLinkTrainingResult:

Returns last result of link training.

###### Returns:

> object of `DpLinkTrainingResult` type

scrambler_seed: int

Returns scrambler seed value.

###### Returns:

> object of `int` type

def get_override_voltage(self, stream_index: int) -> int:

Returns override voltage of selected stream.

###### Arguments:

- stream_index (int) - number of selected stream

###### Returns:

> object of `int` type

def set_override_voltage(self, stream_index: int, value: int):

Returns override voltage of selected stream.

###### Arguments:

- stream_index (int) - number of selected stream
- value (int) - new override voltage value

def get_override_pre_emp(self, stream_index: int) -> int:

Returns override pre-emphasis of selected stream.

###### Arguments:

- stream_index (int) - number of selected stream

###### Returns:

> object of `int` type

def set_override_pre_emp(self, stream_index: int, value: int):

Returns override pre-emphasis of selected stream.

###### Arguments:

- stream_index (int) - number of selected stream
- value (int) - new override pre-emphasis value

override_ffe_presets: list

Returns override FFE presets values.

###### Returns:

> object of `list` type

link_pattern: UniTAP.dev.ports.modules.link.dp.link_tx_types.DPLinkPattern

Returns current DP link pattern `DPLinkPattern`.

###### Returns:

> object of `DPLinkPattern` type

def set_link_pattern( self, pattern: UniTAP.dev.ports.modules.link.dp.link_tx_types.DPLinkPattern, additional_param: int = 1):

Write DP link pattern value `DPLinkPattern`.

###### Arguments:

- pattern (DPLinkPattern) - new pattern value.
- additional_param (int)

def set_force_link_mode( self, link_mode: UniTAP.dev.ports.modules.link.dp.link_tx_types.DPOutLinkMode ):
def get_force_link_mode(self) -> UniTAP.dev.ports.modules.link.dp.link_tx_types.DPOutLinkMode:
def cable_rx_type( self) -> UniTAP.dev.ports.modules.link.dp.link_rx_types.CableCapabilitiesEnum:

Get cable type from the RX side.

###### Returns:

> object of `CableCapabilitiesEnum` type

def cable_tx_type( self) -> UniTAP.dev.ports.modules.link.dp.link_rx_types.CableCapabilitiesEnum:

Get cable type from the TX side.

###### Returns:

> object of `CableCapabilitiesEnum` type